"""
I2P Virtual Host checking script. This script uses 
a large CSV file to try specific I2P host names on 
a given public IP to see if a different page is 
returned. It saves scrapes of these pages to a 
time stamped directory.

Coded by Adrian Crenshaw
Please excuse the sloppiness of the code, I've only recently began to learn Python
http://irongeek.com
"""
import sys
import urllib2
from urllib2 import HTTPError, URLError
import threading
from threading import Thread
import time
from datetime import datetime
import string
import os
import csv
import difflib
import socket
tout = 15
DownIPList=[]
socket.setdefaulttimeout(tout)
ThreadsToRun = 25

ScanStartedTime = string.replace(string.replace(str(datetime.now())," ", "-"),":","-")
os.mkdir("VhostPageScrapes" + ScanStartedTime)
ScrapeDir = "VhostPageScrapes" + ScanStartedTime 
IframeFile=open(ScrapeDir + '\\00iframefun.html', 'wb',1)
InputCSV = csv.reader(open('test.txt', 'r'), delimiter=',', quotechar='"')

#With help from http://forum.i2p2.de/viewtopic.php?p=20843  
#ProxyToUse= urllib2.ProxyHandler({'http': 'http://127.0.0.1:4444/'})
#opener = urllib2.build_opener(ProxyToUse)
#urllib2.install_opener(opener)

def SaveScrape(AnIP, data, TheInfo):
   ScrapeFile=open(ScrapeDir + "\\" + AnIP +'.html', 'wb',1)
   ScrapeFile.write(data)
   OutToFile = AnIP + ":<p><pre>" + TheInfo +"</pre><p><iframe src =\"" + AnIP +'.html' + "\" width=\"100%\" height=\"300\"></iframe>"
   IframeFile.write(OutToFile)
   ScrapeFile.close


def GrabDefaultPage(TheIP):
    defaultpage="error perhaps?"
    TheInfo=""
    needtomakefile = True    
    try:
        BaseHostFileName= "VhostPageScrapes" + ScanStartedTime + "\\" + TheIP + '.html'
        if os.path.exists(BaseHostFileName):
            print "is there"
            needtomakefile = False             
        else:
            print "NOT THERE \n"
            headers ={"Host": TheIP}
            request = urllib2.Request("http://" + TheIP + "/", None, headers)
            url = urllib2.urlopen(request, timeout=tout)            
            defaultpage = url.read()            
            TheInfo = str(url.info())
    except HTTPError, e:
        defaultpage = defaultpage + "<br>" + str(e.code) + e.read() + "<br>" +  str(e.info())
        TheInfo = str(e.info())
    except:
        global DownIPList
        DownIPList.append(TheIP)
        print "While in GrabDefaultPage:", sys.exc_info()
    finally:
            if needtomakefile:
                SaveScrape(TheIP, defaultpage, TheInfo)
                """
                HTMLFile=open(BaseHostFileName, 'wb',1)
                HTMLFile.write(defaultpage)
                HTMLFile.close()
                OutToFile =  "<font color =\"#0000ff\">Just " + TheIP + ":</font><p><iframe src =\"" + TheIP + '.html' + "\" width=\"100%\" height=\"300\"></iframe>"
                IframeFile.write(OutToFile)
                """

class GrabURL(Thread):
   def __init__ (self,TheIP,TheHost):
        Thread.__init__(self)
        self.TheIP = TheIP
        self.TheHost = TheHost
        self.status = -1
   def run(self):
      try:
         BaseHostFileName= "VhostPageScrapes" + ScanStartedTime + "\\" + self.TheIP + '.html'
         if os.path.exists(BaseHostFileName):
             HTMLFile=open(BaseHostFileName, 'rb',1)
             defaultpage = HTMLFile.read()
             HTMLFile.close()
             print self.TheIP
             print self.TheHost
             headers ={"Host": self.TheHost}
             request = urllib2.Request("http://" + self.TheIP + "/", None, headers)
             url = urllib2.urlopen(request, timeout=tout)
             vhostpage= url.read()
             TheInfo=str(url.read())
             pagematcher = difflib.SequenceMatcher(None, vhostpage,defaultpage)
             pagelikeness = pagematcher.ratio()
             print "page likeness: ", pagelikeness
             if  pagelikeness > .75:
                print "same"
             else:
                print "different"
                SaveScrape(self.TheIP, vhostpage, TheInfo)
                """
                HTMLFile=open("VhostPageScrapes" + ScanStartedTime + "\\" + self.TheIP + self.TheHost + '.html', 'wb',1)
                HTMLFile.write(vhostpage)
                HTMLFile.close()
                OutToFile = "<b><font color =\"#ff0000\">Testing " + self.TheHost + " on " + self.TheIP + ":</font></b><p><iframe src =\"" + self.TheIP + self.TheHost + '.html' + "\" width=\"100%\" height=\"300\"></iframe>"
                IframeFile.write(OutToFile)
                """
      except:
         print "While in GrabURL with", self.TheHost , self.TheIP , sys.exc_info()

#TheIP = "178.63.47.16"
#TheHost = "lurker.i2p"

StartingThreadCount=threading.activeCount()
AllStartingThreads= threading.enumerate()
lastIP="0.0.0.0"
for line in InputCSV:
    try:
        TheHost = line[0]
        TheIP = line[1].strip("\n")
        print "\nOn " + TheIP + " " + TheHost
        if TheIP not in DownIPList:
            if lastIP != TheIP:
                    GrabDefaultPage(TheIP)
                    lastIP=TheIP
            
            current = GrabURL(TheIP,TheHost)
            current.start()
            time.sleep(1)
        else:
            print TheIP + " may be down, skipping"
        while  threading.activeCount()>= ThreadsToRun + StartingThreadCount:
          print "\nsleeping, last ran "  + TheIP + " " + TheHost
          time.sleep(1)
    except:
        print sys.exc_info()

while threading.activeCount() > StartingThreadCount:
   print "starting:", StartingThreadCount
   print "now:", threading.activeCount()
   print AllStartingThreads
   print threading.enumerate()
   time.sleep(5)

IframeFile.close()
print "Done"
